"use strict";
/**
 * Utils used across entire package
 * @module
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.findCallSignature = void 0;
const lodash_1 = __importDefault(require("lodash"));
const guards_1 = require("./guards");
/**
 * Loops through signatures of the command's method declaration and returns the first that is a
 * `CallSignatureReflection` (if any).  This is what we think of when we think "function signature"
 */
exports.findCallSignature = lodash_1.default.memoize((refl) => refl?.getAllSignatures()?.find(guards_1.isCallSignatureReflection));
//# sourceMappingURL=utils.js.map